# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

Name:           maven-plugin-tools
Version:        2.4.3
Release:        3%{?dist}
Epoch:          0
Summary:        Maven Plugin Tools
License:        Apache Software License 2.0
Group:          Development/Java
URL:            http://maven.apache.org/plugin-tools/
Source0:        %{name}-%{version}-src.tar.gz
# svn export https://svn.apache.org/repos/asf/maven/shared/tags/maven-plugin-tools-2.4.3
# tar czf maven-plugin-tools-2.4.3-src.tar.gz maven-plugin-tools-2.4.3
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Patch0:         %{name}-pom.patch
Patch1:         %{name}-model-pom.patch
Patch2:         %{name}-plugin-plugin-pom.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%if ! %{gcj_support}
BuildArch:      noarch
%endif

BuildRequires:    jpackage-utils >= 0:1.7.5
BuildRequires:    java-devel >= 0:1.6.0
BuildRequires:    ant >= 0:1.7
BuildRequires:    junit
BuildRequires:    maven2 >= 0:2.0.8
BuildRequires:    maven2-plugin-antrun
BuildRequires:    maven2-plugin-compiler
BuildRequires:    maven2-plugin-install
BuildRequires:    maven2-plugin-jar
BuildRequires:    maven2-plugin-javadoc
BuildRequires:    maven2-plugin-plugin
BuildRequires:    maven2-plugin-release
BuildRequires:    maven2-plugin-site
BuildRequires:    maven-surefire-maven-plugin 
BuildRequires:    maven-surefire-provider-junit 
BuildRequires:    maven-doxia
BuildRequires:    maven-doxia-sitetools
BuildRequires:    maven-shared-plugin-tools-ant
BuildRequires:    maven-shared-plugin-testing-harness
BuildRequires:    maven-shared-reporting-impl
BuildRequires:    modello
BuildRequires:    mojo-maven2-plugin-l10n
BuildRequires:    mojo-maven2-plugin-l10n
BuildRequires:    bsh
BuildRequires:    plexus-container-default
BuildRequires:    plexus-utils
BuildRequires:    jtidy
#BuildRequires:    qdox
BuildRequires:    apache-commons-parent

Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
Provides:       maven2-plugin-plugin = %{epoch}:%{version}-%{release}
Obsoletes:      maven2-plugin-plugin < %{epoch}:%{version}-%{release}
Requires:    java >= 0:1.6.0
Requires:    bsh
Requires:    jtidy
Requires:    maven2 >= 0:2.0.8
Requires:    maven-doxia
Requires:    maven-doxia-sitetools
Requires:    maven-shared-reporting-impl
Requires:    plexus-container-default
Requires:    plexus-utils
#Requires:    qdox

%if %{gcj_support}
BuildRequires:       java-gcj-compat-devel
Requires(post):      java-gcj-compat
Requires(postun):    java-gcj-compat
%endif

%description
The Maven Plugin Tools contains the necessary tools to be 
able to produce Maven Plugins in a variety of languages.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n %{name}-%{version}
%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
#rm -rf maven-plugin-plugin

%build
cp %{SOURCE1} settings.xml
sed -i -e "s|<url>__INTERNAL_REPO_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" settings.xml
sed -i -e "s|<url>__EXTERNAL_REPO_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml

export MAVEN_SETTINGS=$(pwd)/settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
mkdir -p $MAVEN_REPO_LOCAL

mvn-jpp \
    -e \
    -s $MAVEN_SETTINGS \
    -Dmaven.test.failure.ignore=true \
    -Dmaven2.jpp.depmap.file=%{SOURCE2} \
    -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
    install

pushd maven-plugin-plugin
mkdir -p $MAVEN_REPO_LOCAL/JPP/maven2/poms/
cp pom.xml $MAVEN_REPO_LOCAL/JPP/maven2/poms/JPP.maven2.plugins-plugin-plugin.pom
mvn-jpp \
    -e \
    -s $MAVEN_SETTINGS \
    -Dmaven.test.failure.ignore=true \
    -Dmaven2.jpp.depmap.file=%{SOURCE2} \
    -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
    install || :
popd
cp pom.xml.sav0 pom.xml
mvn-jpp \
    -e \
    -s $MAVEN_SETTINGS \
    -Daggregate=true \
    -Dmaven.test.failure.ignore=true \
    -Dmaven2.jpp.depmap.file=%{SOURCE2} \
    -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
    install javadoc:javadoc || :


%install
rm -rf $RPM_BUILD_ROOT
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}

install -m 644 maven-plugin-tools-ant/target/maven-plugin-tools-ant-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/ant-%{version}.jar
install -m 644 maven-plugin-tools-api/target/maven-plugin-tools-api-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/api-%{version}.jar
install -m 644 maven-plugin-tools-beanshell/target/maven-plugin-tools-beanshell-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/beanshell-%{version}.jar
install -m 644 maven-plugin-tools-java/target/maven-plugin-tools-java-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/java-%{version}.jar
install -m 644 maven-plugin-tools-javadoc/target/maven-plugin-tools-javadoc-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/javadoc-%{version}.jar
install -m 644 maven-plugin-tools-model/target/maven-plugin-tools-model-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/model-%{version}.jar
install -m 644 maven-plugin-plugin/target/maven-plugin-plugin-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/plugin-plugin-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; \
  do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

install -pm 644 pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{name}.pom
%add_to_maven_depmap org.apache.maven.plugin-tools %{name} %{version} JPP/%{name} %{name}
%add_to_maven_depmap org.apache.maven %{name} %{version} JPP/%{name} %{name}
 
install -pm 644 maven-plugin-tools-ant/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-ant.pom
%add_to_maven_depmap org.apache.maven.plugin-tools %{name}-ant %{version} JPP/%{name} ant
%add_to_maven_depmap org.apache.maven %{name}-ant %{version} JPP/%{name} ant

install -pm 644 maven-plugin-tools-api/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-api.pom
%add_to_maven_depmap org.apache.maven.plugin-tools %{name}-api %{version} JPP/%{name} api
%add_to_maven_depmap org.apache.maven %{name}-api %{version} JPP/%{name} api

install -pm 644 maven-plugin-tools-beanshell/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-beanshell.pom
%add_to_maven_depmap org.apache.maven.plugin-tools %{name}-beanshell %{version} JPP/%{name} beanshell
%add_to_maven_depmap org.apache.maven %{name}-beanshell %{version} JPP/%{name} beanshell

install -pm 644 maven-plugin-tools-java/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-java.pom
%add_to_maven_depmap org.apache.maven.plugin-tools %{name}-java %{version} JPP/%{name} java
%add_to_maven_depmap org.apache.maven %{name}-java %{version} JPP/%{name} java

install -pm 644 maven-plugin-tools-javadoc/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-javadoc.pom
%add_to_maven_depmap org.apache.maven.plugin-tools %{name}-javadoc %{version} JPP/%{name} javadoc
%add_to_maven_depmap org.apache.maven %{name}-javadoc %{version} JPP/%{name} javadoc

install -pm 644 maven-plugin-tools-model/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-model.pom
%add_to_maven_depmap org.apache.maven.plugin-tools %{name}-model %{version} JPP/%{name} model
%add_to_maven_depmap org.apache.maven %{name}-model %{version} JPP/%{name} model

install -pm 644 maven-plugin-plugin/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-plugin-plugin.pom
%add_to_maven_depmap org.apache.maven.plugins maven-plugin-plugin %{version} JPP/%{name} plugin-plugin
%add_to_maven_depmap org.apache.maven.plugins maven-plugin-plugin %{version} JPP/%{name} plugin-plugin

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}

cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/

ln -s %{name}-%{version} \
     $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root,-)
%{_javadir}/%{name}
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/*
%endif

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/*

%changelog
* Sun Dec 05 2010 Ralph Apel <r.apel@r-apel.de> - 0:2.4.3-3
- Do we need qdox?

* Sat Dec 04 2010 Ralph Apel <r.apel@r-apel.de> - 0:2.4.3-2
- Add alternative depmaps
- Fix for modello-1.3

* Sat Oct 02 2010 Ralph Apel <r.apel@r-apel.de> - 0:2.4.3-1
- 2.4.3 adding maven-plugin-tools-javadoc

* Wed May 20 2009 Fernando Nasser <fnasser@redhat.com> - 0:2.1-3
- Fix license
- Fix URL

* Mon Apr 27 2009 Yong Yang <yyang@redhat.com> - 0:2.1-2
- Add BRs for maven-doxia*
- Rebuild with maven2-2.0.8 built in non-bootstrap mode

* Mon Mar 09 2009 Yong Yang <yyang@redhat.com> - 0:2.1-1
- Import from dbhole's maven2 2.0.8 packages

* Mon Apr 07 2008 Deepak Bhole <dbhole@redhat.com> - 0:2.1-0jpp.1
- Initial build

